﻿using System;

namespace FormeGeometricheAstratte
{
    abstract class PoligonoRegolare : FormaGeometrica
    {
        // Rendiamo pubblici i seguenti due attributi perché sono a sola lettura (readonly)
        // e perché il costruttore della classe provvede a controllare la correttezza dei
        // valori che dovrenno essere assegnati ad essi.
        // Eccezionalmente, quindi, usiamo una iniziale maiuscola perché i due attributi
        // possono essere interpretati come se fossero proprietà pubbliche a sola lettura {query}.
        public readonly int NumeroLati;
        public readonly double LunghezzaLato;

        public PoligonoRegolare(int numLati, double lunLato)
        {
            this.NumeroLati = (numLati >= 3) ? numLati : 3;
            this.LunghezzaLato = (lunLato >= 0.0) ? lunLato : -lunLato;
        }

        public double CalcolaPerimetro()
        {
            return NumeroLati * LunghezzaLato;
        }

        public override string ToString()
        {
            string result = 
                base.ToString() + ", in particolare " +
                "poligono regolare di " + NumeroLati + " lati " +
                "di lunghezza " + LunghezzaLato +
                " e perimetro " + CalcolaPerimetro();

            return result;
        }



    }
}
