﻿using System;

namespace FormeGeometricheAstratte
{
    class Program
    {
        static void ScriviInfoSuConsole(FormaGeometrica[] forme)
        {
            if (forme != null)
                foreach (FormaGeometrica fg in forme)
                    Console.WriteLine(fg + Environment.NewLine);
        }

        static double SommaAree(FormaGeometrica[] forme)
        {
            double result = 0;
            if (forme != null)
                foreach (FormaGeometrica fg in forme)
                    result += fg.CalcolaArea();
            return result;
        }

        static void Main(string[] args)
        {
            FormaGeometrica[] forme =
                new FormaGeometrica[] {new Quadrato(5.6),  new TriangoloEquilatero(3.2)};

            ScriviInfoSuConsole(forme);

            Console.WriteLine("Somma delle aree: " + SommaAree(forme) + Environment.NewLine);

            Console.WriteLine("Premi un tasto per terminare");
            Console.ReadKey();
        }

    }
}
